// -*- mode: c++; c-set-style: "stroustrup"; tab-width: 4; -*-
//
// CReader.h
//
// Copyright (C) 2004 Koji Nakamaru
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#ifndef _CReader_h_
#define _CReader_h_

#include "CFile.h"
#include "CImage.h"

class CReader {
public:
	const char **magic;

	virtual ~CReader();
	virtual bool initialize(CFile *fp, char *magic) = 0;
	virtual void read(CFile *fp, CImage<float, 4> *image) = 0;
	int w();
	int h();

protected:
	int _w;
	int _h;

	CReader();
};

// inline functions

inline int CReader::w()
{
	return _w;
}

inline int CReader::h()
{
	return _h;
}

#endif
